/*
	EkspressHotline.js
	Andmebaas: Ekspress Hotline (www.1182.ee)
	Date: 22.11.2006
	Version: 1.2
	(c) 2006 Filipp Lepalaan <filipp@emug.ee>
	
	"Macintosh Development: thinking different together."
	
	License: You can make any changes you want to this, but it would be
	nice if you send them to me so everyone else could benefit from
	them as well.
	
	Todo (in DESC order of priority)
	- (DONE) PROPER rewrite links - $1 instead of RegExp.$1 // Big thanks fot CommandPrompt!
	- Try: "Otsi"
	- Back/Forward buttons
	- Remember last category
	- Number showing (as in Business.wdgt)
	- cache search results
	- resultsPerPage (count <tr>)
	- Add to AddressBook! (alt-clicking on business name)
	
	Essential reading:
	http://www.regular-expressions.info/javascript.html
	http://developer.apple.com/internet/webcontent/xmlhttpreq.html
	http://www.alistapart.com/articles/gettingstartedwithajax
	http://xkr.us/code/javascript/XHConn/#ref-xml
	http://www.evolt.org/article/Regular_Expressions_in_JavaScript/17/36435/
	http://www.maxkiesler.com/index.php/mhub/alpha/
	http://www.webreference.com/js/column5/backreferences.html
	http://en.wikipedia.org/wiki/Regular_expression
	http://developer.apple.com/documentation/AppleApplications/Reference/SafariJSRef/Classes/Events_index.html
	http://developer.apple.com/documentation/AppleApplications/Reference/SafariWebContent/index.html
	http://developer.apple.com/documentation/AppleApplications/Conceptual/Dashboard_ProgTopics/Articles/Design.html
	http://interfacelift.com/icons-mac/articles/bice/aquatutorial.php
	http://www.codeproject.com/aspnet/JsOOP1.asp
*/

var req, baseUrl, async, cat, nextCat, resultsPerPage, resultsDiv, titleDiv;
var topBar;
var history;
var animator;
var stretcher;
var searchField;
var scrollBarDiv;

var debug = false;

// Define an array of all areas
// Not used ATM
var piirkonnad = [
	'Määramata','Tallinn ja Harjumaa',
	'Hiiumaa','Ida-Virumaa',
	'Jõgevamaa','Järvamaa',
	'Läänemaa','Läänene-Virumaa',
	'Põlvamaa','Pärnumaa',
	'Raplamaa','Saaremaa',
	'Tartumaa','Valgamaa',
	'Viljandimaa','Võrumaa'];

// Map mnemonic keywords to 1182
var categories = [
	{'long' : 'Firma', 'short' : 'nimi'}, 
	{'long' : 'Märksõna', 'short' : 'msona'}, 
	{'long' : 'Eraisik', 'short' : 'era'}];

function loaded ()
{
	nextCat = 0;
	timeout = 5;											// In seconds, for the animation
	async = true;											// For debugging
	resultsPerPage = 10;
	req = new XMLHttpRequest ();							// Create conn object
	baseUrl = 'http://www.1182.ee/baas/';					// Just a timesaver base URL
	req.onreadystatechange = processReqChange;				// Define callback manager
	
	animator = new AppleAnimator (timeout*1000, 1000, 0, 3, updateStatus);
	
	// Throw some hooks into the UI:
	front = document.getElementById			('front');
	topBar = document.getElementById		('topbar');
	scrollBarDiv = document.getElementById	("scrollBar")
	resultsDiv = document.getElementById	('resultsView');
	statusDiv = document.getElementById		('statusTextDiv');
	searchField = document.getElementById	('search-input');
	titleDiv = document.getElementById		('titleScreen-label');
	centerDiv = document.getElementById		('center');
	bottomDiv = document.getElementById		('bottomDiv');
	catImg = document.getElementById 		('categoryImg');
	
	bottomDiv.style.visibility = 'hidden';
	centerDiv.style.visibility = 'hidden';
	
	stretcher	= new Stretcher (front, 160, 250, stretcherDidFinish);
}

// Find anything, clean up entered text
function search (word, longCat, shortCat)
{	
	if (word.length == 0) {			// User clicked X
		return shrink ();
	} else if (word.length < 2) {	// String too short
		return setMessage ('Liiga lühike märksõna.');
	} else {
		category = shortCat;
		setMessage (longCat);
		kw = escape (word);
		url = (shortCat == 'era') ? baseUrl + 'eraa.cgi?nimi=' + kw + '&maakond=99' : baseUrl + 'otsing.cgi?'+shortCat+'='+kw;
		if (debug)
			alert ('opening URL: ' + url);
		req.open ("GET", url, async);
		req.send (null);
	}
}

// Just add some dots to the status text, should cycle around 3
function updateStatus (animation, current, start, finish)
{
	statusDiv.innerText += '.';
}

// Must rewrite links to point to the getInfo () script instead!
// TODO: keyword match links are different:
// This is what the link looks like
// <a href="/?rurl=000002RF&nl=1" target=_blank class=urls >http://www.overall.ee</a>
// Regex:
// Match what's inside <a href="/?rurl=000002RF&nl=1"
// And replace the stuff inside " " with what's inside > <
// widget.openURL(url)
// Strip all images: <img border=0 src=/logo/000000ed.gif width=150>
// Strip all font tags: <font face="Arial, Helvetica, sans-serif" size="2">|</font>
// Strip <table> formatting
// Rewrite homepage: <a href="/?rurl=000002RF&nl=1" target=_blank class=urls >http://www.overall.ee</a>
// Make $1 be the ID and $2 the URL
// So the pattern should be=
// regexLink = /<a href="{\/baas\/disp.cgi\?uid=(.*?)}|">/
// Match whole links, capture ?uid=something and stuff between >and</a>
function parseData (response)
{	
	regex = /<table border=[0-9] cellspacing=[0-9] cellpadding=[0-9] width=[0-9]*?>.*<\/table>/;
	
	if (regex.test (response))										// This is a company listing page
	{
		tmp = regex.exec (response);
		// Must rewrite to something like <a href="javascript:getInfo(000014GINolx6vPPh5RZ8);">
		// Or <a href="javascript:getInfo('http://www.mac.ee')">
		// Match whole anchor
		// Capture (?uid= to ")
		// 2) replace whole match with
		// Anything that starts as a link and ends with "
		// There are many tables, pick just the one with the business info
		regexTable = /<table .*?>/g;								// Match all table tags (& strip formatting)
		regexExtraTable = /<table border=1 cellspacing=0 width=100%>.*<\/table>/	// The optional extra table, remove!
		regexFont = /<font .*?>|<\/font>/g;							// Match all font tags (and not the contents!)
		regexImg = /<img .*?>/g;									// Match all image tags
		regexLink = /<a href="\/baas\/disp.cgi\?uid=(.*?)">/g;		// Rewrite links, count these to get result count!
		//regexKwLink = /<a href="\/?rurl=.*?">(http:\/\/.*)<\/a>/g	// Keyword search result links are a bit different:
		regexHp = /<a href="\/\?rurl=.*?>(http:\/\/.*?)<\/a>/g;
		//regexLink = /<a href=.*?(\?uid=(.*?)")?>(.*?)<\/a>/g;		// Match links, capture after uid and link name, NOT USED
		// $1 = the whole link
		// $2 = Business ID
		// $3 = Business name
		//match = regexLink.exec (tmp[0]);
		if (regexLink.test (tmp[0]))
		{
			id = regexLink.exec (tmp[0]);
			ids = tmp[0].match (regexLink);
			resultCount = ids.length;
			newLink = "<a class=\"businessName\" href=\"javascript:getInfo(\'$1\')\">";
			newHp = "<a onclick=\"widget.openURL(\'$1\')\">$1</a>";
			link = tmp[0].replace (regexLink, newLink);
			output = link.replace (regexImg, '').replace (regexFont, '').replace (regexExtraTable, '').replace (regexTable ,'').replace (regexHp, newHp);	// Replace everything
		} else {
			output = tmp[0];										// If no link, just output everything, no link = no image
			}
	} else {
		return setMessage ('Ei leidnud ühtegi firmat');
		}
	
	setStatus ('Tulemusi: ' + resultCount);
	setResults (output);
}

/*
	Eraisikute muster on erinev
	TODO:
	Add that cool feature in PhoneBook that shows the tel number on the screen:
	- Match whole link
	- Capture number
	- replace with special magic
	<tr bgcolor=#eeeeee>
*/

function parsePeople (response)
{
	regexLink = /<a href=\/baas\/hc.cgi>(.*)<\/a>/g;
	regex = /<table border=0 cellspacing=0 cellpadding=2>[\s\S]*?<\/table>/;
	regexFont = /<font .*?>|<\/font>/g;
	regexTr = /bgcolor=#eeeeee/g;
	
	if (regex.test (response))
	{
		tmp = regex.exec (response);
		links = regexLink.exec (tmp[0]);
		newLink = "<a onclick=\"javascript:showPhoneNumber(\'$1\')\">$1</a>";	// $1 are the captures
		newTr = "class='odd'";
		output = tmp[0].replace (regexLink, newLink).replace (regexFont, '').replace (regexTr, newTr);
	} else {
		return setMessage ('Ei leidnud ühtegi eraisikut.');
		}
		
	setResults (output);
}

// Retrieves info on a particular business
// Clean the id from possible extra params
// Check if ID is an URL and open in new window with widget.openUrl(url)
function getInfo (id)
{	
	url = baseUrl + 'disp.cgi?uid=' + id.replace (/&.*/, '');	// Kind of silly, but works.
	req.open ("GET", url, async);
	category = 'info';											// ditto
	req.send (null);
}

// Parse the info page of a business
// [\s\S] means any character, including \r in JS
// Rewrite homepage links: <a href="http://www.tpt.ee" class="url">http://www.tpt.ee</a>
// <a href="(.*)">.*?<\/a>
function parseInfo (response)
{	
	regex = /<big>[\s\S]*<\!\/small>/;
	
	if (regex.test (response)) {
		out = regex.exec (response);
		regexHp = /<a href="http:\/\/.*?">(.*?)<\/a>/g;
		newHp = "<a onclick=\"widget.openURL(\'$1\')\">$1</a>";
		output = out[0].replace (regexHp, newHp);
	} else {
		scrollBarDiv.style.visibility = 'hidden';				// Don't need it
		return setMessage ('Täpsem info puudub');
		}
	
	setStatus ('');
	setResults (output);	
}

/*
	The callback manager.
	We have 3 states - returning to parse:
	- business data
	- people
	- info on a specific business
*/
function processReqChange () 
{
	setStatus ('Tegutsen');
	
    if (req.readyState == 4)				// only if req shows "loaded"
    {
        if (req.status == 200)				// only if "OK"
        {
        	response = req.responseText;
        	if (debug)
				alert ('response: ' + response);
        	setStatus ('');
        	switch (category)
        	{
        		case 'nimi' : parseData (response); break;
        		case 'info' : parseInfo (response); break;
        		case 'msona': parseData (response); break;
        		case 'era'	: parsePeople (response); break;
        	}
   
			setScrollbar ();
        
        } else {
        	setStatus ('');
        	setMessage ('Ei saanud ühendust');
        }
    }
}

// Show a loader
// http://developer.apple.com/documentation/AppleApplications/Conceptual/Dashboard_ProgTopics/index.html#//apple_ref/doc/uid/TP40002837
function setStatus (status)
{	
	statusDiv.innerText = status;			// getLocalizedString ()
	(status != '') ? animator.start () : animator.stop ();      
}

// Sets the big message text
function setMessage (msg)
{	
	if (!stretcher.isStretched ()) stretcher.stretch ();
	resultsDiv.innerHTML = '';
	//scrollBarDiv.style.visibility = 'hidden';
	scrollBarDiv.style.display = 'none';
	titleDiv.innerText = msg;
	animator.stop ();
}

function setResults (results)
{	
	titleDiv.innerText = '';
	resultsDiv.innerHTML = results;
	scrollBarDiv.style.display = 'block';
	animator.stop ();
}

/*
	Small function to cycle the categories icon
	It's kind of silly keeping short and long 
	category names in sync, but it works for now.
*/

function nextCategory ()
{	
	nextCat++;
	nextCat = (nextCat == categories.length) ? 0 : nextCat++;
	
	catImg.src = 'images/'+categories[nextCat]['long']+'.png';
	catImg.title = categories[nextCat]['long'];
	catImg.name = categories[nextCat]['short'];
	// searchField.placeholder = categories[nextCat]['long']; // WebKit doesn't allow this	
}

// Borrowed from Scroller.wdgt
function setScrollbar ()
{
	scrollbar = new AppleVerticalScrollbar (scrollBarDiv);
	scrollArea = new AppleScrollArea (centerDiv, scrollbar);
	
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 15;
	scrollArea.focus ();						// for key control when first loading in Safari
	
	window.onfocus = function ()	{ scrollArea.focus (); }
	window.onblur =	function ()		{ scrollArea.blur (); }
}

function expanded ()
{	
	topBar.src = 'Images/top-expanded.png';
	bottomDiv.style.visibility = 'visible';
	scrollBarDiv.style.visibility = 'visible';
	centerDiv.style.visibility = 'visible';	
}

function collapsed ()
{
	scrollBarDiv.style.visibility = 'hidden';
	centerDiv.style.visibility = 'hidden';
	bottomDiv.style.visibility = 'hidden';
	topBar.src = 'Images/top.png';	
}
	
function arrowClick (arrow)
{
	(arrow.id == "backArrow") ? history.back () : history.forward ();	
}

// Called every time our stretcher changees state
function stretcherDidFinish ()
{	
	(stretcher.isStretched ()) ?  expanded () : collapsed ();	
}

function shrink ()
{	
	if (stretcher.isStretched ()) {
		stretcher.stretch (collapsed ());
	}	
}

// Do something really special
// Not used in 1.0
function showPhoneNumber (number)
{
	YP.showLargeType (number);
}

// This could be as simple as writing a file name
// after the search term into the widget's support folder
function cacheResults (results)
{
	
}

// The history class
// There's always only up to 3 things in here:
// the past, present and future (if any)
function History ()
{
	this.histIndex	= 0;				// Where we are ATM, 0 is past, etc
	this.histCount	= 0;				// How many things we have here already
	
	function add (something) {			// Adds something to the history stack
		
	}
	
	function back () {
		setStatus ('back');
	}
	
	
	function forward () {
		setStatus ('forward');
	}
}
